<template>
    <div class="container-menus">
        <!-- <div>
            <v-btn
                style="width: 190px; margin: 2px;"
                dark
                :to="{ name: 'ordersRestaurants', params: { id: restaurant.id } }"
            >
                <td style=" margin-left:140px">
                    <span style="font-size: 10px; margin-right: 140px;">
                        <div style="display:inline;  ">
                            {{ getRestaurantName() }}
                        </div>
                        <div style="color: #FBC02D; display:inline; background-color:#333333;">
                            {{ activeOrders }}
                        </div>
                    </span>
                </td>
            </v-btn>
        </div> -->
        <v-menu class="sub-menu">
            <template v-slot:activator="{ on, attrs }">
                <v-expansion-panels dark v-bind="attrs" v-on="on">
                    <v-expansion-panel>
                        <v-expansion-panel-header>
                            <p class="content-restaurant">{{ getRestaurantName() }}</p>
                        </v-expansion-panel-header>
                        <v-expansion-panel-content>
                            <v-list class="content-orders">
                                <v-list-item>
                                    <v-btn
                                        dark
                                        style="width: 100%;"
                                        :to="{ name: 'ordersRestaurants', params: { id: restaurant.id } }"
                                    >
                                        <td style=" margin-left:140px">
                                            <span style="font-size: 10px; margin-right: 140px;">
                                                <div style="display:inline;  ">
                                                    Local
                                                </div>
                                                <div style="color: #FBC02D; display:inline; background-color:#333333;">
                                                    {{ typeLocal }}
                                                </div>
                                            </span>
                                        </td>
                                    </v-btn>
                                </v-list-item>
                                <v-list-item>
                                    <v-btn
                                        dark
                                        style="width: 100%;"
                                        :to="{ name: 'ordersRestaurants', params: { id: restaurant.id } }"
                                    >
                                        <td style=" margin-left:140px">
                                            <span style="font-size: 10px; margin-right: 140px;">
                                                <div style="display:inline;  ">
                                                    Delivery
                                                </div>
                                                <div style="color: #FBC02D; display:inline; background-color:#333333;">
                                                    {{ typeDelivery }}
                                                </div>
                                            </span>
                                        </td>
                                    </v-btn>
                                </v-list-item>
                                <v-list-item>
                                    <v-btn
                                        dark
                                        style="width: 100%;"
                                        :to="{ name: 'ordersRestaurants', params: { id: restaurant.id } }"
                                    >
                                        <td style=" margin-left:140px">
                                            <span style="font-size: 10px; margin-right: 140px;">
                                                <div style="display:inline;  ">
                                                    Pickup
                                                </div>
                                                <div style="color: #FBC02D; display:inline; background-color:#333333;">
                                                    {{ typeCollect }}
                                                </div>
                                            </span>
                                        </td>
                                    </v-btn>
                                </v-list-item>
                            </v-list>
                        </v-expansion-panel-content>
                    </v-expansion-panel>
                </v-expansion-panels>
            </template>
        </v-menu>
        <!-- <v-menu class="sub-menu" origin="center center" transition="scale-transition">
            <template v-slot:activator="{ on, attrs }">
                <v-btn
                dark
                v-bind="attrs"
                v-on="on"
                style="width: 190px; margin: 2px;"
                >
                    <td style=" margin-left:140px">
                        <span style="font-size: 10px; margin-right: 140px;">
                            <div style="display:inline;  ">
                                {{ getRestaurantName() }}
                            </div>
                            <div style="color: #FBC02D; display:inline; background-color:#333333;">
                                {{ activeOrders }}
                            </div>
                        </span>
                    </td>
                </v-btn>
            </template>
            <v-list class="content-orders">
                <v-list-item>
                    <v-btn
                    dark
                    style="width: 100%;"
                    :to="{ name: 'ordersRestaurants', params: { id: restaurant.id } }"
                    >
                        <td style=" margin-left:140px">
                            <span style="font-size: 10px; margin-right: 140px;">
                                <div style="display:inline;  ">
                                    Local
                                </div>
                                <div style="color: #FBC02D; display:inline; background-color:#333333;">
                                    {{ typeLocal }}
                                </div>
                            </span>
                        </td>
                    </v-btn>
                </v-list-item>
                <v-list-item>
                    <v-btn
                    dark
                    style="width: 100%;"
                    :to="{ name: 'ordersRestaurants', params: { id: restaurant.id } }"
                    >
                        <td style=" margin-left:140px">
                            <span style="font-size: 10px; margin-right: 140px;">
                                <div style="display:inline;  ">
                                    Delivery
                                </div>
                                <div style="color: #FBC02D; display:inline; background-color:#333333;">
                                    {{ typeDelivery }}
                                </div>
                            </span>
                        </td>
                    </v-btn>
                </v-list-item>
                <v-list-item>
                    <v-btn
                    dark
                    style="width: 100%;"
                    :to="{ name: 'ordersRestaurants', params: { id: restaurant.id } }"
                    >
                        <td style=" margin-left:140px">
                            <span style="font-size: 10px; margin-right: 140px;">
                                <div style="display:inline;  ">
                                    Collect
                                </div>
                                <div style="color: #FBC02D; display:inline; background-color:#333333;">
                                    {{ typeCollect }}
                                </div>
                            </span>
                        </td>
                    </v-btn>
                </v-list-item>
            </v-list>
        </v-menu> -->
    </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';
import { db } from '@/config/firebase';
import { ORDERS } from '@/config/collectionsName';
import { serializeOrder } from '@/config/serializables';
import { Order, StatusOrder, TypeOrder } from '@/model/order/Order';
import { Restaurant } from '@/model/Restaurant';
import firebase from 'firebase/app';
import Timestamp = firebase.firestore.Timestamp;

@Component
export default class NotificationItem extends Vue {
    @Prop({ default: new Restaurant('', '', false, [], Timestamp.now()) })
    readonly restaurant!: Restaurant;
    closeOnContentClick = true;
    order: Order[] = [];

    async created() {
        await this.$bind('order', db.collection(ORDERS).where('restaurantId', '==', this.restaurant.id), {
            serialize: serializeOrder
        });
    }

    get activeOrders(): number {
        const pending = this.order.filter(orders => orders.status == StatusOrder.PENDING);
        return pending.length;
    }

    get typeLocal(): number {
        const local = this.order.filter(orders => orders.type == TypeOrder.LOCAL);
        const pending = local.filter(orders => orders.status == StatusOrder.PENDING);
        return pending.length;
    }

    get typeDelivery(): number {
        const delivery = this.order.filter(orders => orders.type == TypeOrder.DELIVERY);
        const pending = delivery.filter(orders => orders.status == StatusOrder.PENDING);
        return pending.length;
    }

    get typeCollect(): number {
        const collect = this.order.filter(orders => orders.type == TypeOrder.COLLECT);
        const pending = collect.filter(orders => orders.status == StatusOrder.PENDING);
        return pending.length;
    }

    getRestaurantName() {
        return this.restaurant.name;
    }
}
</script>

<style type="scss">
.v-menu__content {
    margin-top: 55px;
}
.content-orders {
    margin-left: -2px;
}
.content-restaurant {
    overflow-wrap: break-word;
    width: 50pt;
}
</style>
